# Copyright (c) 1994,1995 James Clark
# See the file COPYING for copying permission.

# Makefile for Watcom C/C++ 10.0a
CXX=wcl386
srcdir=E:\sp
TARGET=dos
LINK_SYSTEM=dos4g
STACK_SIZE=128k
OPTIMIZE=/oilr /zp4 /4
SEARCHPATH=$(srcdir)\lib;$(srcdir)\parser;$(srcdir)\em;$(srcdir)\app;$(srcdir)\nsgmls;$(srcdir)\rast;$(srcdir)\spam
CXXFLAGS=/bt=$(TARGET) /zq $(OPTIMIZE) /i=$(SEARCHPATH)
LIBFLAGS=-p=32
LDFLAGS=/l=$(LINK_SYSTEM) /k$(STACK_SIZE)

NSGMLS_OBJS=nsgmls.obj SgmlsEventHandler.obj StringSet.obj nsgmls_inst.obj
RAST_OBJS=rast.obj
SPAM_OBJS=spam.obj CopyEventHandler.obj spam_inst.obj
LIB_OBJS=Allocator.obj Link.obj IListBase.obj TypeId.obj &
  assert.obj version.obj &
  Parser.obj parseInstance.obj parseMode.obj parseAttribute.obj parseSd.obj &
  LinkProcess.obj Lpd.obj parseDecl.obj &
  parseParam.obj parseCommon.obj SgmlParser.obj &
  Entity.obj Attribute.obj OpenElement.obj Notation.obj &
  ParserOptions.obj Dtd.obj &
  ParserState.obj Undo.obj Param.obj TokenMessageArg.obj Group.obj &
  UnivCharsetDesc.obj CharsetInfo.obj &
  CharsetDecl.obj CharsetRegistry.obj ExternalId.obj &
  TrieBuilder.obj Sd.obj Syntax.obj Partition.obj ModeInfo.obj Recognizer.obj &
  InputSource.obj Location.obj MessageArg.obj Decl.obj &
  Text.obj ContentToken.obj ElementType.obj Event.obj &
  InternalInputSource.obj OutputState.obj Fragments.obj &
  Message.obj ParserMessages.obj &
  Hash.obj parser_inst.obj &
  ErrnoMessageArg.obj OffsetOrderedList.obj DescriptorManager.obj &
  EntityManager.obj Catalog.obj PosixStorage.obj StdioStorage.obj &
  PosixHttpStorage.obj StorageManager.obj &
  CodingSystem.obj IdentityCodingSystem.obj &
  UTF8CodingSystem.obj UCS2CodingSystem.obj UnicodeCodingSystem.obj &
  UJISCodingSystem.obj SJISCodingSystem.obj em_inst.obj &
  EasyParser.obj MessageEventHandler.obj MessageReporter.obj &
  OutputCharStream.obj RastEventHandler.obj app_inst.obj &
  LineOutputCodingSystem.obj programName.obj getopt.obj outOfMemory.obj

LIB=libsp.lib

all: nsgmls.exe rast.exe spam.exe

nsgmls.exe: $(NSGMLS_OBJS) $(LIB)
	$(CXX) $(NSGMLS_OBJS) $(LIB) /fe=$@ $(CXXFLAGS) $(LDFLAGS)

rast.exe: $(RAST_OBJS) $(LIB)
	$(CXX) $(RAST_OBJS) $(LIB) /fe=$@ $(CXXFLAGS) $(LDFLAGS)

spam.exe: $(SPAM_OBJS) $(LIB)
	$(CXX) $(SPAM_OBJS) $(LIB) /fe=$@ $(CXXFLAGS) $(LDFLAGS)

$(LIB): $(LIB_OBJS)
	wlib $(LIBFLAGS) $(LIB) $?

.C.obj: .AUTODEPEND
	$(CXX) $[@ /c /cc++ $(CXXFLAGS)

.C: $(SEARCHPATH)
