// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#include "config.h"
#include <sys/types.h>
#ifdef INCLUDE_UNISTD_H
#include <unistd.h>
#endif
#ifdef INCLUDE_IO_H
#include <io.h>
#endif
#include <string.h>
#include <stdlib.h>

#include "programName.H"

static
void ewrite(const char *s)
{
  int n = (int)strlen(s);
  while (n > 0) {
    int nw = write(2, s, n);
    if (nw < 0)
      break;
    n -= nw;
    s += nw;
  }
}

#ifdef FANCY_NEW_HANDLER
int outOfMemory(size_t)
#else
void outOfMemory()
#endif
{
  if (programName) {
    ewrite(programName);
    ewrite(": ");
  }
  ewrite(": out of memory\n");
  exit(1);
#ifdef FANCY_NEW_HANDLER
  return 0;
#endif  
}
