// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#include "config.h"

#ifdef MANUAL_INST

#define DEFINE_TEMPLATES
#include "StringOf.H"
#include "Vector.H"
#include "GrowableVector.H"
#include "GrowableVectorD.H"
#include "CopyGrowableVectorD.H"
#include "HashTable.H"
#include "ListIter.H"
#include "IList.H"
#include "List.H"
#include "DOwner.H"
#undef DEFINE_TEMPLATES

#include "StorageManager.H"
#include "EntityManager.H"
#include "OffsetOrderedList.H"
#include "CodingSystem.H"
#include "Catalog.H"
#include "types.H"
#include "StringOf.H"
#include "DescriptorManager.H"
#include "StorageManager.H"
#include "Boolean.H"
#include "RegisteredCodingSystem.H"
#include "StorageObjectPosition.H"
class StorageManager;

#ifdef __DECCXX
#pragma define_template String<char>
#else
#ifdef ANSI_CLASS_INST
template class String<char>;
#else
typedef String<char> Dummy_0;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<DOwner<StorageObject> >
#else
#ifdef ANSI_CLASS_INST
template class Vector<DOwner<StorageObject> >;
#else
typedef Vector<DOwner<StorageObject> > Dummy_1;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<StorageObjectSpec>
#else
#ifdef ANSI_CLASS_INST
template class GrowableVectorD<StorageObjectSpec>;
#else
typedef GrowableVectorD<StorageObjectSpec> Dummy_2;
#endif
#endif
#ifdef __DECCXX
#pragma define_template CopyGrowableVectorD<StorageObjectSpec>
#else
#ifdef ANSI_CLASS_INST
template class CopyGrowableVectorD<StorageObjectSpec>;
#else
typedef CopyGrowableVectorD<StorageObjectSpec> Dummy_3;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVectorD<DOwner<OffsetOrderedListBlock> >
#else
#ifdef ANSI_CLASS_INST
template class GrowableVectorD<DOwner<OffsetOrderedListBlock> >;
#else
typedef GrowableVectorD<DOwner<OffsetOrderedListBlock> > Dummy_4;
#endif
#endif
#ifdef __DECCXX
#pragma define_template Vector<StorageObjectPosition>
#else
#ifdef ANSI_CLASS_INST
template class Vector<StorageObjectPosition>;
#else
typedef Vector<StorageObjectPosition> Dummy_5;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTable<String<Char>,CatalogEntry>
#else
#ifdef ANSI_CLASS_INST
template class HashTable<String<Char>,CatalogEntry>;
#else
typedef HashTable<String<Char>,CatalogEntry> Dummy_6;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTableIter<String<Char>,CatalogEntry>
#else
#ifdef ANSI_CLASS_INST
template class HashTableIter<String<Char>,CatalogEntry>;
#else
typedef HashTableIter<String<Char>,CatalogEntry> Dummy_7;
#endif
#endif
#ifdef __DECCXX
#pragma define_template HashTableItem<String<Char>, CatalogEntry>
#else
#ifdef ANSI_CLASS_INST
template class HashTableItem<String<Char>, CatalogEntry>;
#else
typedef HashTableItem<String<Char>, CatalogEntry> Dummy_8;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IList<ListItem<DescriptorUser*> >
#else
#ifdef ANSI_CLASS_INST
template class IList<ListItem<DescriptorUser*> >;
#else
typedef IList<ListItem<DescriptorUser*> > Dummy_9;
#endif
#endif
#ifdef __DECCXX
#pragma define_template List<DescriptorUser*>
#else
#ifdef ANSI_CLASS_INST
template class List<DescriptorUser*>;
#else
typedef List<DescriptorUser*> Dummy_10;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ListIter<DescriptorUser *>
#else
#ifdef ANSI_CLASS_INST
template class ListIter<DescriptorUser *>;
#else
typedef ListIter<DescriptorUser *> Dummy_11;
#endif
#endif
#ifdef __DECCXX
#pragma define_template ListItem<DescriptorUser*>
#else
#ifdef ANSI_CLASS_INST
template class ListItem<DescriptorUser*>;
#else
typedef ListItem<DescriptorUser*> Dummy_12;
#endif
#endif
#ifdef __DECCXX
#pragma define_template IListIter<ListItem<DescriptorUser*> >
#else
#ifdef ANSI_CLASS_INST
template class IListIter<ListItem<DescriptorUser*> >;
#else
typedef IListIter<ListItem<DescriptorUser*> > Dummy_13;
#endif
#endif
#ifdef __DECCXX
#pragma define_template DOwner<StorageObject>
#else
#ifdef ANSI_CLASS_INST
template class DOwner<StorageObject>;
#else
typedef DOwner<StorageObject> Dummy_14;
#endif
#endif
#ifdef __DECCXX
#pragma define_template DOwner<Decoder>
#else
#ifdef ANSI_CLASS_INST
template class DOwner<Decoder>;
#else
typedef DOwner<Decoder> Dummy_15;
#endif
#endif
#ifdef __DECCXX
#pragma define_template DOwner<OffsetOrderedListBlock>
#else
#ifdef ANSI_CLASS_INST
template class DOwner<OffsetOrderedListBlock>;
#else
typedef DOwner<OffsetOrderedListBlock> Dummy_16;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<StorageManager *>
#else
#ifdef ANSI_CLASS_INST
template class GrowableVector<StorageManager *>;
#else
typedef GrowableVector<StorageManager *> Dummy_17;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<PackedBoolean>
#else
#ifdef ANSI_CLASS_INST
template class GrowableVector<PackedBoolean>;
#else
typedef GrowableVector<PackedBoolean> Dummy_18;
#endif
#endif
#ifdef __DECCXX
#pragma define_template GrowableVector<RegisteredCodingSystem>
#else
#ifdef ANSI_CLASS_INST
template class GrowableVector<RegisteredCodingSystem>;
#else
typedef GrowableVector<RegisteredCodingSystem> Dummy_19;
#endif
#endif

#endif /* MANUAL_INST */
