// Copyright (c) 1995 James Clark
// See the file COPYING for copying permission.

#ifndef Decl_INCLUDED
#define Decl_INCLUDED 1

#ifdef __GNUG__
#pragma interface
#endif

#include "CString.H"
#include "Syntax.H"
#include "Location.H"
#include "GrowableVectorD.H"

struct DeclItem {
  enum Type {
    other,
    delimiter,
    reservedName,
    indicatedReservedName,
    name,
    comment,
    s,
    entityStart,
    entityEnd
  };
  Type type;
  Location loc;
  union {
    Syntax::DelimGeneral delimIndex;
    Syntax::ReservedName reservedNameIndex;
  };
  CString str;
};

class Decl : public GrowableVectorD<DeclItem> {
public:
  Decl();
private:
  Decl(const Decl &);		// undefined
  void operator=(const Decl &);	// undefined
};

#endif /* not Decl_INCLUDED */
