// Copyright (c) 1994 James Clark
// See the file COPYING for copying permission.

#ifndef EventsWanted_INCLUDED
#define EventsWanted_INCLUDED 1

#include "Boolean.H"

class EventsWanted {
public:
  EventsWanted();
  Boolean wantEsisPlus() const;
  Boolean wantCommentDecls() const;
  Boolean wantMarkedSections() const;
  void addEsisPlus();
  void addCommentDecls();
  void addMarkedSections();
private:
  PackedBoolean esisPlus_;
  PackedBoolean commentDecls_;
  PackedBoolean markedSections_;
};

inline
EventsWanted::EventsWanted()
: esisPlus_(0)
{
}

inline
Boolean EventsWanted::wantEsisPlus() const
{
  return esisPlus_;
}

inline
void EventsWanted::addEsisPlus()
{
  esisPlus_ = 1;
  commentDecls_ = 1;
  markedSections_ = 1;
}

inline
Boolean EventsWanted::wantCommentDecls() const
{
  return commentDecls_;
}

inline
void EventsWanted::addCommentDecls()
{
  commentDecls_ = 1;
}

inline
Boolean EventsWanted::wantMarkedSections() const
{
  return markedSections_;
}

inline
void EventsWanted::addMarkedSections()
{
  markedSections_ = 1;
}

#endif /* not EventsWanted_INCLUDED */
