// Copyright (c) 1995 James Clark
// See the file COPYING for copying permission.

#ifndef SGMLGenerator_INCLUDED
#define SGMLGenerator_INCLUDED 1
#ifdef __GNUG__
#pragma interface
#endif

#include "Boolean.H"
#include "SGMLApplication.H"
#include "OutputCharStream.H"
#include "StringOf.H"

class SGMLGenerator : public SGMLApplication {
public:
  SGMLGenerator(OutputCharStream *);
  void startElement(const StartElementEvent &);
  void endElement(const EndElementEvent &);
  void data(const DataEvent &);
  void sdata(const SdataEvent &);
  void pi(const PiEvent &);
  void externalDataEntityRef(const ExternalDataEntityRefEvent &);
  void subdocEntityRef(const SubdocEntityRefEvent &);
  void endProlog(const EndPrologEvent &);
  void commentDecl(const CommentDeclEvent &);
  void markedSectionStart(const MarkedSectionStartEvent &);
  void markedSectionEnd(const MarkedSectionEndEvent &);
  void ignoredChars(const IgnoredCharsEvent &);
  void end();
private:
  OutputCharStream &os();
  void numCharRef(unsigned long n);
  void entityRef(const CharString &);
  void flushRe();
  void outputRe();
  Boolean isSgmlChar(Char);
  void attributeChars(const CharString &str);

  OutputCharStream *os_;
  enum {
    other,
    pendingRe,
    afterStartTag
    };
  char outputState_;
  String<char> outputStateStack_;
  String<char> isElementContentStack_;
  Boolean mustOmitEndTag_;
  enum {
    normalMode,
    cdataMode,
    rcdataMode
    } parseMode_;
  unsigned markedSectionDepth_;
  PackedBoolean nonSgml_[256];
  Boolean inInstance_;
};

#endif /* not SGMLGenerator_INCLUDED */
