.tr \(ts"
.TH SPAM 1
.SH NAME
spam \- an SGML normalizer
.sp
An \*S System Conforming to
.if n .br
International Standard ISO 8879 \(em
.br
Standard Generalized Markup Language
.SH SYNOPSIS
.B spam
[
.B \-ehipwx
]
[
.BI \-c catalog_file
]
[
.BI \-m markup_option
]
[
.BI \-o entity_name
]
.I sysid\|.\|.\|.
.SH DESCRIPTION
.I Spam
(SP Add Markup)
is a normalizer implemented using the SP parser.
.I Spam
parses the SGML document contained in
.I sysid\|.\|.\|.
and copies to the standard output
the portion of the document entity containing the document
instance, adding or changing markup as specified by the
.B \-m
option.
The
.B \-p
option can be used to include the SGML declaration and prolog
in the output.
The
.B \-o
option can be used to output other entities.
The
.B \-x
option can be used to expand entity references.
.LP
For more information about the underlying SGML parser and entity
manager, see
.BR nsgmls (1).
.LP
The following options are available:
.TP
.BI \-c file
Use the catalog entry file
.IR file .
.TP
.B \-e
Describe open entities in error messages.
.TP
.B \-h
Hoist omitted tags out from the start of internal entities.
If the text at the beginning of an interal entity causes
a tag to be implied,
the tag will usually be treated as being in that internal entity;
this option will instead cause it to be treated as being in the entity
that referenced the internal entity.
This option makes a difference in conjunction with
.B \-momittag
or
.BR \-x\ \-x .
.TP
.BI \-i name
Pretend that
.RS
.IP
.BI <!ENTITY\ %\  name\  \(tsINCLUDE\(ts>
.LP
occurs at the start of the document type declaration subset
in the \*S document entity.
.RE
.TP
.BI -m markup_option
Change the markup in the output according to the value
of
.I markup_option
as follows:
.RS
.TP
.B omittag
Add tags that were omitted using omitted tag minimization.
End tags that were omitted because the element has
a declared content of
.SM EMPTY
or an explicit content reference
will not be added.
.TP
.B shortref
Replace short references by named entity references.
.TP
.B net
Change null end-tags
into unminimized end-tags,
and change net-enabling start-tags
into unminimized start-tags.
.TP
.B emptytag
Change empty tags into unminimized tags.
.TP
.B unclosed
Change unclosed tags into unminimized tags.
.TP
.B attname
Add omitted attribute names and
.BR vi s.
.TP
.B attvalue
Add literal delimiters omitted from attribute values.
.TP
.B attspec
Add omitted attribute specifications.
.TP
.B shorttag
Equivalent to combination of
.BR net ,
.BR emptytag ,
.BR unclosed ,
.BR attname ,
.B attvalue
and
.B attspec
options.
.TP
.B rank
Add omitted rank suffixes.
.LP
Multiple
.B \-m
options are allowed.
.RE
.TP
.BI \-o name
Output the entity
.I name
instead of the document entity.
The output will correspond to the first time
that the entity is referenced in content.
.TP
.B \-p
Output the SGML declaration and prolog before anything else.
This option will cause the document entity to be read
a second time; it will therefore not work with pipes.
.TP
.B \-w
Give warnings.
.TP
.B \-x
Expand references to entities that are changed.
If this option is specified more than once,
then all references to entities that contain tags
will be expanded.
.SH BUGS
.LP
Omitted tags are added at the point where they are
implied by the SGML parser (except as modified
by the
.B \-h
option); this is often not quite where they are wanted.
.LP
Start-tags and end-tags that contain a name group in their
document type specification are not output.
.LP
Entity references that contain a name group are not output.
.LP
The case of general delimiters is not preserved.
.SH AUTHOR
.LP
James Clark (jjc@jclark.com).
.SH "SEE ALSO"
.BR nsgmls (1)
